# Google

使用网页爬虫API，您可以抓取并解析各种类型的 **Google** 页面；以下是所有受支持的爬虫及其相应 `source` 值的概览。

<table><thead><tr><th width="260">来源</th><th>描述</th><th>专用解析器</th></tr></thead><tbody><tr><td><code>google_search</code></td><td>搜索结果页面。（<a href="/pages/2ae6768d07f4f24437e547f9aebcb314d6a06f0c"><strong>网页</strong></a>, <a href="/pages/8d39cce62ffe3f635c5175d6e6408fb68d7ad556"><strong>图片</strong></a>, <a href="/pages/bca456e98d1e5e108e652b004cdd3cda14423ab2"><strong>新闻</strong></a><strong>,</strong> <a href="/pages/02ea6d72e1cdc5be5b4cd6208afda852fb8dfcf5"><strong>AI Overviews</strong></a>)</td><td>是。</td></tr><tr><td><code>google_ads</code></td><td>搜索结果页面，针对 <a href="/pages/95e571fd6e2dd19bec3eabcc504cf6fbac0659c2"><strong>最大广告率</strong></a>.</td><td>是。</td></tr><tr><td><code>google_ai_mode</code></td><td><a href="/pages/24cf156319973fd79c666b380e540e5e8b84b100"><strong>Google AI 模式</strong></a>  对话式回复。</td><td>是。</td></tr><tr><td><code>谷歌镜头</code></td><td><a href="/pages/1231a0f8e5fca55fd8ef65d211c6da2bbde77783"><strong>Google Lens</strong></a> 服务。</td><td>是。</td></tr><tr><td><code>google_maps</code></td><td><a href="/pages/fa07ba746f8da9fd2e4b9a32a31e72b75e27b76e"><strong>本地搜索</strong></a> 服务。</td><td>否。</td></tr><tr><td><code>google_trends_explore</code></td><td><a href="/pages/9cc55515895d499b7ca89b45cc9673de720bafda"><strong>趋势</strong></a>.</td><td>否。</td></tr><tr><td><code>google_travel_hotels</code></td><td><a href="/pages/68f2e801b766256be80eca7af6c0660260e85540"><strong>旅行：酒店</strong></a> 服务。</td><td>否。</td></tr><tr><td><code>google_shopping_product</code></td><td><a href="/pages/d099ca0378a18968be0c68a7e5384b7a83e21bc6"><strong>产品</strong></a> 您所选产品 token 的页面。</td><td>是。</td></tr><tr><td><code>google_shopping_search</code></td><td><a href="/pages/30d7939fc93399a0d2145330a434d63293c2a611"><strong>搜索</strong></a> 您所选搜索词的结果。</td><td>是。</td></tr><tr><td><code>谷歌</code></td><td>提交任何 Google <a href="/pages/8699117476ab4e20a45acd47104c3a4416a818f9"><strong>URL</strong></a> 。</td><td>仅限特定的 URL <a href="/pages/55be38a1fe24f7b9e3a53af4997ef9dffa756d02"><strong>Google 页面类型</strong></a>.</td></tr></tbody></table>

{% hint style="info" %}
尽管我们没有为每个 Google 源提供专用解析器，但您可以使用 [**自定义解析器**](/products/cn/web-scraper-api/features/custom-parser.md) 功能并获取结构化数据。
{% endhint %}

## 入门

**创建您的 API 用户凭证**：注册免费试用或在 [**Oxylabs 仪表板**](https://dashboard.oxylabs.io/en/registration) 中购买产品，以创建您的 API 用户凭证（`USERNAME` 和 `PASSWORD`).

{% hint style="warning" %}
如果您的账户需要多个 API 用户，请联系我们的 [**客户支持**](mailto:support@oxylabs.io) 或通过我们 24/7 在线聊天支持发送消息。
{% endhint %}

### 请求样本

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "google_search",
        "query": "adidas",
        "geo_location": "California,United States",
        "parse": true
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# 结构化负载。
payload = {
    'source': 'google_search',
    'query': 'adidas',
    'geo_location': 'California,United States',
    'parse': True
}

# 获取响应。
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# 将格式化后的响应打印到标准输出。
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "google_search",
    query: "adidas",
    geo_location: "California,United States",
    parse: true,
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("错误：", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'google_search',
    'query' => 'adidas',
    'geo_location' => 'California,United States',
    'parse' => true
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo '错误:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "google_search",
                query = "adidas",
                geo_location = "California,United States",
                parse = true
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.Encoding.ASCII.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{} {
		"source":       "google_search",
		"query":        "adidas",
		"geo_location": "California,United States",
		"parse":        true,
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	request.Header.Set("Content-Type", "application/json")
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://Realtime.oxylabs.io/v1/queries?source=google_search&query=adidas&geo_location=California%2CUnited%20States&parse=true&access_token=12345abcde
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "google_search");
        jsonObject.put("query", "adidas");
        jsonObject.put("geo_location", "California,United States");
        jsonObject.put("parse", true);

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("错误： " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "google_search",
    "query": "adidas",
    "geo_location": "California,United States",
    "parse": true
}
```

{% endtab %}
{% endtabs %}

{% file src="/files/94a5b58ed4680ea5a6019f80fb7eee9258774c5e" %}

我们在示例中使用同步 [**Realtime**](/products/cn/web-scraper-api/integration-methods/realtime.md) 集成方法。如果您想使用 [**Proxy Endpoint**](/products/cn/web-scraper-api/integration-methods/proxy-endpoint.md) 或异步 [**Push-Pull**](/products/cn/web-scraper-api/integration-methods/push-pull.md) 集成，请参阅 [**集成方法**](/products/cn/web-scraper-api/integration-methods.md) 部分。

可选地，您还可以包含其他参数，例如 `geo_location`, `user_agent_type`, `parse`, `render` 以及更多内容，以自定义您的抓取请求。阅读更多：


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/api-targets/cn/sou-suo-yin-qing/google.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
